// automatically generated by the FlatBuffers compiler, do not modify


#ifndef FLATBUFFERS_GENERATED_ACTKERNEL_MVCNN_H_
#define FLATBUFFERS_GENERATED_ACTKERNEL_MVCNN_H_

#include "flatbuffers/flatbuffers.h"

#include "memoryManagement_generated.h"
#include "structure_generated.h"

namespace MVCNN {

struct PerfPayloadConfig;
struct PerfPayloadConfigBuilder;

struct ActKernel;
struct ActKernelBuilder;

struct ActKernelInvocation;
struct ActKernelInvocationBuilder;

struct ActKernelTask;
struct ActKernelTaskBuilder;

struct ActKernelRuntime;
struct ActKernelRuntimeBuilder;

enum ActKernelType {
  ActKernelType_KERNEL = 0,
  ActKernelType_DEBUG = 1,
  ActKernelType_DXIL_KERNEL = 2,
  /// Used for describing L2Cache operations an ActShave might need to do before or after
  /// executing the ActKernel with Type == KERNEL. Handled by the ActRuntimeRuntime internally
  /// Add these as a separate ActKernel entry with 1 ActKernelInvocation for barrier information
  ActKernelType_CACHE_OP_FLUSH = 3,
  ActKernelType_CACHE_OP_INVALIDATE = 4,
  ActKernelType_CACHE_OP_FLUSHINV = 5,
  ActKernelType_NOP = 127,
  ActKernelType_MIN = ActKernelType_KERNEL,
  ActKernelType_MAX = ActKernelType_NOP
};

inline const ActKernelType (&EnumValuesActKernelType())[7] {
  static const ActKernelType values[] = {
    ActKernelType_KERNEL,
    ActKernelType_DEBUG,
    ActKernelType_DXIL_KERNEL,
    ActKernelType_CACHE_OP_FLUSH,
    ActKernelType_CACHE_OP_INVALIDATE,
    ActKernelType_CACHE_OP_FLUSHINV,
    ActKernelType_NOP
  };
  return values;
}

inline const char *EnumNameActKernelType(ActKernelType e) {
  switch (e) {
    case ActKernelType_KERNEL: return "KERNEL";
    case ActKernelType_DEBUG: return "DEBUG";
    case ActKernelType_DXIL_KERNEL: return "DXIL_KERNEL";
    case ActKernelType_CACHE_OP_FLUSH: return "CACHE_OP_FLUSH";
    case ActKernelType_CACHE_OP_INVALIDATE: return "CACHE_OP_INVALIDATE";
    case ActKernelType_CACHE_OP_FLUSHINV: return "CACHE_OP_FLUSHINV";
    case ActKernelType_NOP: return "NOP";
    default: return "";
  }
}

enum ActKernelPerfCounter {
  /// Stall cycle
  ActKernelPerfCounter_STALL_CYCLE_CNT_EN = 0,
  /// Executed instruction
  ActKernelPerfCounter_EXEC_INST_CNT_EN = 1,
  /// Clock cycle
  ActKernelPerfCounter_CLK_CYCLE_CNT_EN = 2,
  /// Branch taken
  ActKernelPerfCounter_BRANCH_TAKEN_CNT_EN = 3,
  /// Instruction breakpoint 0
  ActKernelPerfCounter_INST_BRKP0_CNT_EN = 4,
  /// Instruction breakpoint 1
  ActKernelPerfCounter_INST_BRKP1_CNT_EN = 5,
  /// Data breakpoint 0
  ActKernelPerfCounter_DATA_BRKP0_CNT_EN = 6,
  /// Data breakpoint 1
  ActKernelPerfCounter_DATA_BRKP1_CNT_EN = 7,
  /// Go counter of Operation Control Register
  ActKernelPerfCounter_GO_COUNT_EN = 8,
  /// LSU0 read transaction byte
  ActKernelPerfCounter_LSU0_RBYTE_CNT_EN = 9,
  /// LSU0 write transaction byte
  ActKernelPerfCounter_LSU0_WBYTE_CNT_EN = 10,
  /// LSU1 read transaction byte
  ActKernelPerfCounter_LSU1_RBYTE_CNT_EN = 11,
  /// LSU1 write transaction byte
  ActKernelPerfCounter_LSU1_WBYTE_CNT_EN = 12,
  ActKernelPerfCounter_MIN = ActKernelPerfCounter_STALL_CYCLE_CNT_EN,
  ActKernelPerfCounter_MAX = ActKernelPerfCounter_LSU1_WBYTE_CNT_EN
};

inline const ActKernelPerfCounter (&EnumValuesActKernelPerfCounter())[13] {
  static const ActKernelPerfCounter values[] = {
    ActKernelPerfCounter_STALL_CYCLE_CNT_EN,
    ActKernelPerfCounter_EXEC_INST_CNT_EN,
    ActKernelPerfCounter_CLK_CYCLE_CNT_EN,
    ActKernelPerfCounter_BRANCH_TAKEN_CNT_EN,
    ActKernelPerfCounter_INST_BRKP0_CNT_EN,
    ActKernelPerfCounter_INST_BRKP1_CNT_EN,
    ActKernelPerfCounter_DATA_BRKP0_CNT_EN,
    ActKernelPerfCounter_DATA_BRKP1_CNT_EN,
    ActKernelPerfCounter_GO_COUNT_EN,
    ActKernelPerfCounter_LSU0_RBYTE_CNT_EN,
    ActKernelPerfCounter_LSU0_WBYTE_CNT_EN,
    ActKernelPerfCounter_LSU1_RBYTE_CNT_EN,
    ActKernelPerfCounter_LSU1_WBYTE_CNT_EN
  };
  return values;
}

inline const char * const *EnumNamesActKernelPerfCounter() {
  static const char * const names[14] = {
    "STALL_CYCLE_CNT_EN",
    "EXEC_INST_CNT_EN",
    "CLK_CYCLE_CNT_EN",
    "BRANCH_TAKEN_CNT_EN",
    "INST_BRKP0_CNT_EN",
    "INST_BRKP1_CNT_EN",
    "DATA_BRKP0_CNT_EN",
    "DATA_BRKP1_CNT_EN",
    "GO_COUNT_EN",
    "LSU0_RBYTE_CNT_EN",
    "LSU0_WBYTE_CNT_EN",
    "LSU1_RBYTE_CNT_EN",
    "LSU1_WBYTE_CNT_EN",
    nullptr
  };
  return names;
}

inline const char *EnumNameActKernelPerfCounter(ActKernelPerfCounter e) {
  if (flatbuffers::IsOutRange(e, ActKernelPerfCounter_STALL_CYCLE_CNT_EN, ActKernelPerfCounter_LSU1_WBYTE_CNT_EN)) return "";
  const size_t index = static_cast<size_t>(e);
  return EnumNamesActKernelPerfCounter()[index];
}

enum ActKernelPerfStallFilter {
  /// SW Interrupt Handler
  ActKernelPerfStallFilter_SWIH = 16,
  /// Other interrupts
  ActKernelPerfStallFilter_OTHER_INTR = 17,
  /// LSU0 Stall (waiting for data)
  ActKernelPerfStallFilter_LSU0_DATA_WAIT = 18,
  /// LSU1 Stall (waiting for data)
  ActKernelPerfStallFilter_LSU1_DATA_WAIT = 19,
  /// LSU0 Access Stall
  ActKernelPerfStallFilter_LSU0_ACCESS = 20,
  /// LSU1 Access Stall
  ActKernelPerfStallFilter_LSU1_ACCESS = 21,
  /// Instruction buffer Low Stall
  ActKernelPerfStallFilter_INST_BUFF_LOW = 22,
  /// Discontinuity Fetch Stall
  ActKernelPerfStallFilter_DISC_FETCH = 23,
  /// Discontinuity Decode Stall (too much data in instruction buffer at end of delay slots)
  ActKernelPerfStallFilter_DISC_DEC = 24,
  /// Discontinuity Starve Stall
  ActKernelPerfStallFilter_DISC_STARVE = 25,
  /// Instruction buffer Low during discontinuity
  ActKernelPerfStallFilter_INST_BUFF_LOW_DISC = 26,
  ActKernelPerfStallFilter_MIN = ActKernelPerfStallFilter_SWIH,
  ActKernelPerfStallFilter_MAX = ActKernelPerfStallFilter_INST_BUFF_LOW_DISC
};

inline const ActKernelPerfStallFilter (&EnumValuesActKernelPerfStallFilter())[11] {
  static const ActKernelPerfStallFilter values[] = {
    ActKernelPerfStallFilter_SWIH,
    ActKernelPerfStallFilter_OTHER_INTR,
    ActKernelPerfStallFilter_LSU0_DATA_WAIT,
    ActKernelPerfStallFilter_LSU1_DATA_WAIT,
    ActKernelPerfStallFilter_LSU0_ACCESS,
    ActKernelPerfStallFilter_LSU1_ACCESS,
    ActKernelPerfStallFilter_INST_BUFF_LOW,
    ActKernelPerfStallFilter_DISC_FETCH,
    ActKernelPerfStallFilter_DISC_DEC,
    ActKernelPerfStallFilter_DISC_STARVE,
    ActKernelPerfStallFilter_INST_BUFF_LOW_DISC
  };
  return values;
}

inline const char * const *EnumNamesActKernelPerfStallFilter() {
  static const char * const names[12] = {
    "SWIH",
    "OTHER_INTR",
    "LSU0_DATA_WAIT",
    "LSU1_DATA_WAIT",
    "LSU0_ACCESS",
    "LSU1_ACCESS",
    "INST_BUFF_LOW",
    "DISC_FETCH",
    "DISC_DEC",
    "DISC_STARVE",
    "INST_BUFF_LOW_DISC",
    nullptr
  };
  return names;
}

inline const char *EnumNameActKernelPerfStallFilter(ActKernelPerfStallFilter e) {
  if (flatbuffers::IsOutRange(e, ActKernelPerfStallFilter_SWIH, ActKernelPerfStallFilter_INST_BUFF_LOW_DISC)) return "";
  const size_t index = static_cast<size_t>(e) - static_cast<size_t>(ActKernelPerfStallFilter_SWIH);
  return EnumNamesActKernelPerfStallFilter()[index];
}

struct PerfPayloadConfig FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef PerfPayloadConfigBuilder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "MVCNN.PerfPayloadConfig";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_FRCTIMESTAMP = 4,
    VT_FRCDURATION = 6,
    VT_COUNTERS = 8,
    VT_STALLFILTERS = 10
  };
  /// Use the Free Running Counter
  /// 64b
  bool frcTimestamp() const {
    return GetField<uint8_t>(VT_FRCTIMESTAMP, 0) != 0;
  }
  /// Duration measured by FRC
  /// 32b
  bool frcDuration() const {
    return GetField<uint8_t>(VT_FRCDURATION, 0) != 0;
  }
  const flatbuffers::Vector<int8_t> *counters() const {
    return GetPointer<const flatbuffers::Vector<int8_t> *>(VT_COUNTERS);
  }
  /// Only applicable if STALL_CYCLE_CNT_EN is set as one of the counter targets in `counters`.
  /// This setting is ignored otherwise.
  const flatbuffers::Vector<int8_t> *stallFilters() const {
    return GetPointer<const flatbuffers::Vector<int8_t> *>(VT_STALLFILTERS);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyField<uint8_t>(verifier, VT_FRCTIMESTAMP) &&
           VerifyField<uint8_t>(verifier, VT_FRCDURATION) &&
           VerifyOffset(verifier, VT_COUNTERS) &&
           verifier.VerifyVector(counters()) &&
           VerifyOffset(verifier, VT_STALLFILTERS) &&
           verifier.VerifyVector(stallFilters()) &&
           verifier.EndTable();
  }
};

struct PerfPayloadConfigBuilder {
  typedef PerfPayloadConfig Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_frcTimestamp(bool frcTimestamp) {
    fbb_.AddElement<uint8_t>(PerfPayloadConfig::VT_FRCTIMESTAMP, static_cast<uint8_t>(frcTimestamp), 0);
  }
  void add_frcDuration(bool frcDuration) {
    fbb_.AddElement<uint8_t>(PerfPayloadConfig::VT_FRCDURATION, static_cast<uint8_t>(frcDuration), 0);
  }
  void add_counters(flatbuffers::Offset<flatbuffers::Vector<int8_t>> counters) {
    fbb_.AddOffset(PerfPayloadConfig::VT_COUNTERS, counters);
  }
  void add_stallFilters(flatbuffers::Offset<flatbuffers::Vector<int8_t>> stallFilters) {
    fbb_.AddOffset(PerfPayloadConfig::VT_STALLFILTERS, stallFilters);
  }
  explicit PerfPayloadConfigBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  PerfPayloadConfigBuilder &operator=(const PerfPayloadConfigBuilder &);
  flatbuffers::Offset<PerfPayloadConfig> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<PerfPayloadConfig>(end);
    return o;
  }
};

inline flatbuffers::Offset<PerfPayloadConfig> CreatePerfPayloadConfig(
    flatbuffers::FlatBufferBuilder &_fbb,
    bool frcTimestamp = false,
    bool frcDuration = false,
    flatbuffers::Offset<flatbuffers::Vector<int8_t>> counters = 0,
    flatbuffers::Offset<flatbuffers::Vector<int8_t>> stallFilters = 0) {
  PerfPayloadConfigBuilder builder_(_fbb);
  builder_.add_stallFilters(stallFilters);
  builder_.add_counters(counters);
  builder_.add_frcDuration(frcDuration);
  builder_.add_frcTimestamp(frcTimestamp);
  return builder_.Finish();
}

inline flatbuffers::Offset<PerfPayloadConfig> CreatePerfPayloadConfigDirect(
    flatbuffers::FlatBufferBuilder &_fbb,
    bool frcTimestamp = false,
    bool frcDuration = false,
    const std::vector<int8_t> *counters = nullptr,
    const std::vector<int8_t> *stallFilters = nullptr) {
  auto counters__ = counters ? _fbb.CreateVector<int8_t>(*counters) : 0;
  auto stallFilters__ = stallFilters ? _fbb.CreateVector<int8_t>(*stallFilters) : 0;
  return MVCNN::CreatePerfPayloadConfig(
      _fbb,
      frcTimestamp,
      frcDuration,
      counters__,
      stallFilters__);
}

struct ActKernel FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef ActKernelBuilder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "MVCNN.ActKernel";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_TYPE = 4,
    VT_KERNELTEXT = 6,
    VT_KERNELENTRY = 8,
    VT_GLOBALARGS = 10,
    VT_KERNELIDENTIFIER = 12,
    VT_KERNELVERSIONMAJOR = 14,
    VT_KERNELVERSIONMINOR = 16
  };
  /// This object describes the activation kernel itself. It specifies the size and entry
  /// of the kernel binary, the size of the `.data` section of all associated invocations,
  /// and a type specifier intended for future extensibility.
  /// A type identifier allowing for the FW to do special handling of work items
  MVCNN::ActKernelType type() const {
    return static_cast<MVCNN::ActKernelType>(GetField<int8_t>(VT_TYPE, 0));
  }
  /// the a monolithic kernel's .text section
  const MVCNN::KernelDataReference *kernelText() const {
    return GetPointer<const MVCNN::KernelDataReference *>(VT_KERNELTEXT);
  }
  /// the entry point of the kernel given as an offset from the start of the
  /// kernelText's address
  uint32_t kernelEntry() const {
    return GetField<uint32_t>(VT_KERNELENTRY, 0);
  }
  const MVCNN::KernelDataReference *globalArgs() const {
    return GetPointer<const MVCNN::KernelDataReference *>(VT_GLOBALARGS);
  }
  const flatbuffers::String *kernelIdentifier() const {
    return GetPointer<const flatbuffers::String *>(VT_KERNELIDENTIFIER);
  }
  uint16_t kernelVersionMajor() const {
    return GetField<uint16_t>(VT_KERNELVERSIONMAJOR, 0);
  }
  uint16_t kernelVersionMinor() const {
    return GetField<uint16_t>(VT_KERNELVERSIONMINOR, 0);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyField<int8_t>(verifier, VT_TYPE) &&
           VerifyOffset(verifier, VT_KERNELTEXT) &&
           verifier.VerifyTable(kernelText()) &&
           VerifyField<uint32_t>(verifier, VT_KERNELENTRY) &&
           VerifyOffset(verifier, VT_GLOBALARGS) &&
           verifier.VerifyTable(globalArgs()) &&
           VerifyOffset(verifier, VT_KERNELIDENTIFIER) &&
           verifier.VerifyString(kernelIdentifier()) &&
           VerifyField<uint16_t>(verifier, VT_KERNELVERSIONMAJOR) &&
           VerifyField<uint16_t>(verifier, VT_KERNELVERSIONMINOR) &&
           verifier.EndTable();
  }
};

struct ActKernelBuilder {
  typedef ActKernel Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_type(MVCNN::ActKernelType type) {
    fbb_.AddElement<int8_t>(ActKernel::VT_TYPE, static_cast<int8_t>(type), 0);
  }
  void add_kernelText(flatbuffers::Offset<MVCNN::KernelDataReference> kernelText) {
    fbb_.AddOffset(ActKernel::VT_KERNELTEXT, kernelText);
  }
  void add_kernelEntry(uint32_t kernelEntry) {
    fbb_.AddElement<uint32_t>(ActKernel::VT_KERNELENTRY, kernelEntry, 0);
  }
  void add_globalArgs(flatbuffers::Offset<MVCNN::KernelDataReference> globalArgs) {
    fbb_.AddOffset(ActKernel::VT_GLOBALARGS, globalArgs);
  }
  void add_kernelIdentifier(flatbuffers::Offset<flatbuffers::String> kernelIdentifier) {
    fbb_.AddOffset(ActKernel::VT_KERNELIDENTIFIER, kernelIdentifier);
  }
  void add_kernelVersionMajor(uint16_t kernelVersionMajor) {
    fbb_.AddElement<uint16_t>(ActKernel::VT_KERNELVERSIONMAJOR, kernelVersionMajor, 0);
  }
  void add_kernelVersionMinor(uint16_t kernelVersionMinor) {
    fbb_.AddElement<uint16_t>(ActKernel::VT_KERNELVERSIONMINOR, kernelVersionMinor, 0);
  }
  explicit ActKernelBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  ActKernelBuilder &operator=(const ActKernelBuilder &);
  flatbuffers::Offset<ActKernel> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<ActKernel>(end);
    return o;
  }
};

inline flatbuffers::Offset<ActKernel> CreateActKernel(
    flatbuffers::FlatBufferBuilder &_fbb,
    MVCNN::ActKernelType type = MVCNN::ActKernelType_KERNEL,
    flatbuffers::Offset<MVCNN::KernelDataReference> kernelText = 0,
    uint32_t kernelEntry = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> globalArgs = 0,
    flatbuffers::Offset<flatbuffers::String> kernelIdentifier = 0,
    uint16_t kernelVersionMajor = 0,
    uint16_t kernelVersionMinor = 0) {
  ActKernelBuilder builder_(_fbb);
  builder_.add_kernelIdentifier(kernelIdentifier);
  builder_.add_globalArgs(globalArgs);
  builder_.add_kernelEntry(kernelEntry);
  builder_.add_kernelText(kernelText);
  builder_.add_kernelVersionMinor(kernelVersionMinor);
  builder_.add_kernelVersionMajor(kernelVersionMajor);
  builder_.add_type(type);
  return builder_.Finish();
}

inline flatbuffers::Offset<ActKernel> CreateActKernelDirect(
    flatbuffers::FlatBufferBuilder &_fbb,
    MVCNN::ActKernelType type = MVCNN::ActKernelType_KERNEL,
    flatbuffers::Offset<MVCNN::KernelDataReference> kernelText = 0,
    uint32_t kernelEntry = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> globalArgs = 0,
    const char *kernelIdentifier = nullptr,
    uint16_t kernelVersionMajor = 0,
    uint16_t kernelVersionMinor = 0) {
  auto kernelIdentifier__ = kernelIdentifier ? _fbb.CreateString(kernelIdentifier) : 0;
  return MVCNN::CreateActKernel(
      _fbb,
      type,
      kernelText,
      kernelEntry,
      globalArgs,
      kernelIdentifier__,
      kernelVersionMajor,
      kernelVersionMinor);
}

struct ActKernelInvocation FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef ActKernelInvocationBuilder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "MVCNN.ActKernelInvocation";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_ASSOCIATEDBARRIERS = 4,
    VT_DATASECTION = 6,
    VT_INVOCATIONARGS = 8,
    VT_PERFPAYLOAD = 10,
    VT_TILE = 12,
    VT_INPUTTENSORS = 14,
    VT_OUTPUTTENSORS = 16
  };
  /// This object exists to differentiate invocations of the kernel range.
  /// Unlike DPU Tasks, the ActKernelTask and associated Kernel are not bound by barriers
  const MVCNN::BarrierReference *associatedBarriers() const {
    return GetPointer<const MVCNN::BarrierReference *>(VT_ASSOCIATEDBARRIERS);
  }
  /// the monolithic kernel's .data section. There is a unique data section per-invocation
  const MVCNN::KernelDataReference *dataSection() const {
    return GetPointer<const MVCNN::KernelDataReference *>(VT_DATASECTION);
  }
  /// This buffer represents the generic input arguments that all Activation SHAVE kernels share.
  const MVCNN::KernelDataReference *invocationArgs() const {
    return GetPointer<const MVCNN::KernelDataReference *>(VT_INVOCATIONARGS);
  }
  /// In short; this parameter determines _if_ performance data is captured this Invocation
  const MVCNN::KernelDataReference *perfPayload() const {
    return GetPointer<const MVCNN::KernelDataReference *>(VT_PERFPAYLOAD);
  }
  uint32_t tile() const {
    return GetField<uint32_t>(VT_TILE, 0);
  }
  /// Adding fields to the schema such that we can use the tensor dimensions for for performance predictions.
  const flatbuffers::Vector<flatbuffers::Offset<MVCNN::TensorReference>> *inputTensors() const {
    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<MVCNN::TensorReference>> *>(VT_INPUTTENSORS);
  }
  const flatbuffers::Vector<flatbuffers::Offset<MVCNN::TensorReference>> *outputTensors() const {
    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<MVCNN::TensorReference>> *>(VT_OUTPUTTENSORS);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyOffset(verifier, VT_ASSOCIATEDBARRIERS) &&
           verifier.VerifyTable(associatedBarriers()) &&
           VerifyOffset(verifier, VT_DATASECTION) &&
           verifier.VerifyTable(dataSection()) &&
           VerifyOffset(verifier, VT_INVOCATIONARGS) &&
           verifier.VerifyTable(invocationArgs()) &&
           VerifyOffset(verifier, VT_PERFPAYLOAD) &&
           verifier.VerifyTable(perfPayload()) &&
           VerifyField<uint32_t>(verifier, VT_TILE) &&
           VerifyOffset(verifier, VT_INPUTTENSORS) &&
           verifier.VerifyVector(inputTensors()) &&
           verifier.VerifyVectorOfTables(inputTensors()) &&
           VerifyOffset(verifier, VT_OUTPUTTENSORS) &&
           verifier.VerifyVector(outputTensors()) &&
           verifier.VerifyVectorOfTables(outputTensors()) &&
           verifier.EndTable();
  }
};

struct ActKernelInvocationBuilder {
  typedef ActKernelInvocation Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_associatedBarriers(flatbuffers::Offset<MVCNN::BarrierReference> associatedBarriers) {
    fbb_.AddOffset(ActKernelInvocation::VT_ASSOCIATEDBARRIERS, associatedBarriers);
  }
  void add_dataSection(flatbuffers::Offset<MVCNN::KernelDataReference> dataSection) {
    fbb_.AddOffset(ActKernelInvocation::VT_DATASECTION, dataSection);
  }
  void add_invocationArgs(flatbuffers::Offset<MVCNN::KernelDataReference> invocationArgs) {
    fbb_.AddOffset(ActKernelInvocation::VT_INVOCATIONARGS, invocationArgs);
  }
  void add_perfPayload(flatbuffers::Offset<MVCNN::KernelDataReference> perfPayload) {
    fbb_.AddOffset(ActKernelInvocation::VT_PERFPAYLOAD, perfPayload);
  }
  void add_tile(uint32_t tile) {
    fbb_.AddElement<uint32_t>(ActKernelInvocation::VT_TILE, tile, 0);
  }
  void add_inputTensors(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<MVCNN::TensorReference>>> inputTensors) {
    fbb_.AddOffset(ActKernelInvocation::VT_INPUTTENSORS, inputTensors);
  }
  void add_outputTensors(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<MVCNN::TensorReference>>> outputTensors) {
    fbb_.AddOffset(ActKernelInvocation::VT_OUTPUTTENSORS, outputTensors);
  }
  explicit ActKernelInvocationBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  ActKernelInvocationBuilder &operator=(const ActKernelInvocationBuilder &);
  flatbuffers::Offset<ActKernelInvocation> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<ActKernelInvocation>(end);
    return o;
  }
};

inline flatbuffers::Offset<ActKernelInvocation> CreateActKernelInvocation(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<MVCNN::BarrierReference> associatedBarriers = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> dataSection = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> invocationArgs = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> perfPayload = 0,
    uint32_t tile = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<MVCNN::TensorReference>>> inputTensors = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<MVCNN::TensorReference>>> outputTensors = 0) {
  ActKernelInvocationBuilder builder_(_fbb);
  builder_.add_outputTensors(outputTensors);
  builder_.add_inputTensors(inputTensors);
  builder_.add_tile(tile);
  builder_.add_perfPayload(perfPayload);
  builder_.add_invocationArgs(invocationArgs);
  builder_.add_dataSection(dataSection);
  builder_.add_associatedBarriers(associatedBarriers);
  return builder_.Finish();
}

inline flatbuffers::Offset<ActKernelInvocation> CreateActKernelInvocationDirect(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<MVCNN::BarrierReference> associatedBarriers = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> dataSection = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> invocationArgs = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> perfPayload = 0,
    uint32_t tile = 0,
    const std::vector<flatbuffers::Offset<MVCNN::TensorReference>> *inputTensors = nullptr,
    const std::vector<flatbuffers::Offset<MVCNN::TensorReference>> *outputTensors = nullptr) {
  auto inputTensors__ = inputTensors ? _fbb.CreateVector<flatbuffers::Offset<MVCNN::TensorReference>>(*inputTensors) : 0;
  auto outputTensors__ = outputTensors ? _fbb.CreateVector<flatbuffers::Offset<MVCNN::TensorReference>>(*outputTensors) : 0;
  return MVCNN::CreateActKernelInvocation(
      _fbb,
      associatedBarriers,
      dataSection,
      invocationArgs,
      perfPayload,
      tile,
      inputTensors__,
      outputTensors__);
}

struct ActKernelTask FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef ActKernelTaskBuilder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "MVCNN.ActKernelTask";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_KERNEL = 4,
    VT_INVOCATIONS = 6,
    VT_LAYERTYPE = 8
  };
  /// This object describes an entire Activation SHAVE Kernel ND Range and
  /// the configurations for the kernel invocations within that range.
  const MVCNN::ActKernel *kernel() const {
    return GetPointer<const MVCNN::ActKernel *>(VT_KERNEL);
  }
  const flatbuffers::Vector<flatbuffers::Offset<MVCNN::ActKernelInvocation>> *invocations() const {
    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<MVCNN::ActKernelInvocation>> *>(VT_INVOCATIONS);
  }
  const flatbuffers::String *layerType() const {
    return GetPointer<const flatbuffers::String *>(VT_LAYERTYPE);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyOffset(verifier, VT_KERNEL) &&
           verifier.VerifyTable(kernel()) &&
           VerifyOffset(verifier, VT_INVOCATIONS) &&
           verifier.VerifyVector(invocations()) &&
           verifier.VerifyVectorOfTables(invocations()) &&
           VerifyOffset(verifier, VT_LAYERTYPE) &&
           verifier.VerifyString(layerType()) &&
           verifier.EndTable();
  }
};

struct ActKernelTaskBuilder {
  typedef ActKernelTask Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_kernel(flatbuffers::Offset<MVCNN::ActKernel> kernel) {
    fbb_.AddOffset(ActKernelTask::VT_KERNEL, kernel);
  }
  void add_invocations(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<MVCNN::ActKernelInvocation>>> invocations) {
    fbb_.AddOffset(ActKernelTask::VT_INVOCATIONS, invocations);
  }
  void add_layerType(flatbuffers::Offset<flatbuffers::String> layerType) {
    fbb_.AddOffset(ActKernelTask::VT_LAYERTYPE, layerType);
  }
  explicit ActKernelTaskBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  ActKernelTaskBuilder &operator=(const ActKernelTaskBuilder &);
  flatbuffers::Offset<ActKernelTask> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<ActKernelTask>(end);
    return o;
  }
};

inline flatbuffers::Offset<ActKernelTask> CreateActKernelTask(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<MVCNN::ActKernel> kernel = 0,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<MVCNN::ActKernelInvocation>>> invocations = 0,
    flatbuffers::Offset<flatbuffers::String> layerType = 0) {
  ActKernelTaskBuilder builder_(_fbb);
  builder_.add_layerType(layerType);
  builder_.add_invocations(invocations);
  builder_.add_kernel(kernel);
  return builder_.Finish();
}

inline flatbuffers::Offset<ActKernelTask> CreateActKernelTaskDirect(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<MVCNN::ActKernel> kernel = 0,
    const std::vector<flatbuffers::Offset<MVCNN::ActKernelInvocation>> *invocations = nullptr,
    const char *layerType = nullptr) {
  auto invocations__ = invocations ? _fbb.CreateVector<flatbuffers::Offset<MVCNN::ActKernelInvocation>>(*invocations) : 0;
  auto layerType__ = layerType ? _fbb.CreateString(layerType) : 0;
  return MVCNN::CreateActKernelTask(
      _fbb,
      kernel,
      invocations__,
      layerType__);
}

struct ActKernelRuntime FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef ActKernelRuntimeBuilder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "MVCNN.ActKernelRuntime";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_SHAVESTACKS = 4,
    VT_KERNEL = 6,
    VT_PERFCONFIG = 8,
    VT_CODESCRATCHBUFFER = 10
  };
  /// This object exist to accommodate the firmware to execute the Activation SHAVE Runtime
  /// The schedule allocated space used for the runtime stack(s).
  const flatbuffers::Vector<flatbuffers::Offset<MVCNN::KernelDataReference>> *shaveStacks() const {
    return GetPointer<const flatbuffers::Vector<flatbuffers::Offset<MVCNN::KernelDataReference>> *>(VT_SHAVESTACKS);
  }
  const MVCNN::ActKernel *kernel() const {
    return GetPointer<const MVCNN::ActKernel *>(VT_KERNEL);
  }
  const MVCNN::PerfPayloadConfig *perfConfig() const {
    return GetPointer<const MVCNN::PerfPayloadConfig *>(VT_PERFCONFIG);
  }
  const MVCNN::KernelDataReference *codeScratchBuffer() const {
    return GetPointer<const MVCNN::KernelDataReference *>(VT_CODESCRATCHBUFFER);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyOffset(verifier, VT_SHAVESTACKS) &&
           verifier.VerifyVector(shaveStacks()) &&
           verifier.VerifyVectorOfTables(shaveStacks()) &&
           VerifyOffset(verifier, VT_KERNEL) &&
           verifier.VerifyTable(kernel()) &&
           VerifyOffset(verifier, VT_PERFCONFIG) &&
           verifier.VerifyTable(perfConfig()) &&
           VerifyOffset(verifier, VT_CODESCRATCHBUFFER) &&
           verifier.VerifyTable(codeScratchBuffer()) &&
           verifier.EndTable();
  }
};

struct ActKernelRuntimeBuilder {
  typedef ActKernelRuntime Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_shaveStacks(flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<MVCNN::KernelDataReference>>> shaveStacks) {
    fbb_.AddOffset(ActKernelRuntime::VT_SHAVESTACKS, shaveStacks);
  }
  void add_kernel(flatbuffers::Offset<MVCNN::ActKernel> kernel) {
    fbb_.AddOffset(ActKernelRuntime::VT_KERNEL, kernel);
  }
  void add_perfConfig(flatbuffers::Offset<MVCNN::PerfPayloadConfig> perfConfig) {
    fbb_.AddOffset(ActKernelRuntime::VT_PERFCONFIG, perfConfig);
  }
  void add_codeScratchBuffer(flatbuffers::Offset<MVCNN::KernelDataReference> codeScratchBuffer) {
    fbb_.AddOffset(ActKernelRuntime::VT_CODESCRATCHBUFFER, codeScratchBuffer);
  }
  explicit ActKernelRuntimeBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  ActKernelRuntimeBuilder &operator=(const ActKernelRuntimeBuilder &);
  flatbuffers::Offset<ActKernelRuntime> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<ActKernelRuntime>(end);
    return o;
  }
};

inline flatbuffers::Offset<ActKernelRuntime> CreateActKernelRuntime(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<flatbuffers::Vector<flatbuffers::Offset<MVCNN::KernelDataReference>>> shaveStacks = 0,
    flatbuffers::Offset<MVCNN::ActKernel> kernel = 0,
    flatbuffers::Offset<MVCNN::PerfPayloadConfig> perfConfig = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> codeScratchBuffer = 0) {
  ActKernelRuntimeBuilder builder_(_fbb);
  builder_.add_codeScratchBuffer(codeScratchBuffer);
  builder_.add_perfConfig(perfConfig);
  builder_.add_kernel(kernel);
  builder_.add_shaveStacks(shaveStacks);
  return builder_.Finish();
}

inline flatbuffers::Offset<ActKernelRuntime> CreateActKernelRuntimeDirect(
    flatbuffers::FlatBufferBuilder &_fbb,
    const std::vector<flatbuffers::Offset<MVCNN::KernelDataReference>> *shaveStacks = nullptr,
    flatbuffers::Offset<MVCNN::ActKernel> kernel = 0,
    flatbuffers::Offset<MVCNN::PerfPayloadConfig> perfConfig = 0,
    flatbuffers::Offset<MVCNN::KernelDataReference> codeScratchBuffer = 0) {
  auto shaveStacks__ = shaveStacks ? _fbb.CreateVector<flatbuffers::Offset<MVCNN::KernelDataReference>>(*shaveStacks) : 0;
  return MVCNN::CreateActKernelRuntime(
      _fbb,
      shaveStacks__,
      kernel,
      perfConfig,
      codeScratchBuffer);
}

}  // namespace MVCNN

#endif  // FLATBUFFERS_GENERATED_ACTKERNEL_MVCNN_H_
