// automatically generated by the FlatBuffers compiler, do not modify


#ifndef FLATBUFFERS_GENERATED_DMA_MVCNN_H_
#define FLATBUFFERS_GENERATED_DMA_MVCNN_H_

#include "flatbuffers/flatbuffers.h"

#include "memoryManagement_generated.h"

namespace MVCNN {

struct DMADescriptorReference;

struct NNDMATask;
struct NNDMATaskBuilder;

FLATBUFFERS_MANUALLY_ALIGNED_STRUCT(4) DMADescriptorReference FLATBUFFERS_FINAL_CLASS {
 private:
  uint32_t len_;
  uint32_t src_width_;
  uint32_t src_stride_;
  uint32_t src_plane_stride_;
  uint32_t dst_width_;
  uint32_t dst_stride_;
  uint32_t dst_plane_stride_;
  uint32_t num_planes_;

 public:
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "MVCNN.DMADescriptorReference";
  }
  DMADescriptorReference() {
    memset(static_cast<void *>(this), 0, sizeof(DMADescriptorReference));
  }
  DMADescriptorReference(uint32_t _len, uint32_t _src_width, uint32_t _src_stride, uint32_t _src_plane_stride, uint32_t _dst_width, uint32_t _dst_stride, uint32_t _dst_plane_stride, uint32_t _num_planes)
      : len_(flatbuffers::EndianScalar(_len)),
        src_width_(flatbuffers::EndianScalar(_src_width)),
        src_stride_(flatbuffers::EndianScalar(_src_stride)),
        src_plane_stride_(flatbuffers::EndianScalar(_src_plane_stride)),
        dst_width_(flatbuffers::EndianScalar(_dst_width)),
        dst_stride_(flatbuffers::EndianScalar(_dst_stride)),
        dst_plane_stride_(flatbuffers::EndianScalar(_dst_plane_stride)),
        num_planes_(flatbuffers::EndianScalar(_num_planes)) {
  }
  /// Information of actual DMA descriptor that generate from compiler
  uint32_t len() const {
    return flatbuffers::EndianScalar(len_);
  }
  uint32_t src_width() const {
    return flatbuffers::EndianScalar(src_width_);
  }
  uint32_t src_stride() const {
    return flatbuffers::EndianScalar(src_stride_);
  }
  uint32_t src_plane_stride() const {
    return flatbuffers::EndianScalar(src_plane_stride_);
  }
  uint32_t dst_width() const {
    return flatbuffers::EndianScalar(dst_width_);
  }
  uint32_t dst_stride() const {
    return flatbuffers::EndianScalar(dst_stride_);
  }
  uint32_t dst_plane_stride() const {
    return flatbuffers::EndianScalar(dst_plane_stride_);
  }
  uint32_t num_planes() const {
    return flatbuffers::EndianScalar(num_planes_);
  }
};
FLATBUFFERS_STRUCT_END(DMADescriptorReference, 32);

struct NNDMATask FLATBUFFERS_FINAL_CLASS : private flatbuffers::Table {
  typedef NNDMATaskBuilder Builder;
  static FLATBUFFERS_CONSTEXPR const char *GetFullyQualifiedName() {
    return "MVCNN.NNDMATask";
  }
  enum FlatBuffersVTableOffset FLATBUFFERS_VTABLE_UNDERLYING_TYPE {
    VT_SRC = 4,
    VT_DST = 6,
    VT_COMPRESSION = 8,
    VT_PORT = 10,
    VT_SET_ORD = 12,
    VT_SET_CRIT = 14,
    VT_DESCRIPTOR = 16,
    VT_DMA_HWP_ID = 18,
    VT_ACT_COMPRESSION_SIZE_ENTRY = 20
  };
  /// The NNDMA has a few additional features.
  /// multiple destination tensors represents copy to several locations
  /// on device it can be DMA bradcast
  const MVCNN::TensorReference *src() const {
    return GetPointer<const MVCNN::TensorReference *>(VT_SRC);
  }
  const MVCNN::TensorReference *dst() const {
    return GetPointer<const MVCNN::TensorReference *>(VT_DST);
  }
  /// The NNDMA also has support for compression while transferring.
  /// This is a simple on/off switch for the feature.
  bool compression() const {
    return GetField<uint8_t>(VT_COMPRESSION, 0) != 0;
  }
  /// DMA port which the DMA task will execute on
  uint8_t port() const {
    return GetField<uint8_t>(VT_PORT, 0);
  }
  bool set_ord() const {
    return GetField<uint8_t>(VT_SET_ORD, 0) != 0;
  }
  bool set_crit() const {
    return GetField<uint8_t>(VT_SET_CRIT, 0) != 0;
  }
  const MVCNN::DMADescriptorReference *descriptor() const {
    return GetStruct<const MVCNN::DMADescriptorReference *>(VT_DESCRIPTOR);
  }
  int32_t dma_hwp_id() const {
    return GetField<int32_t>(VT_DMA_HWP_ID, 0);
  }
  const MVCNN::TensorReference *act_compression_size_entry() const {
    return GetPointer<const MVCNN::TensorReference *>(VT_ACT_COMPRESSION_SIZE_ENTRY);
  }
  bool Verify(flatbuffers::Verifier &verifier) const {
    return VerifyTableStart(verifier) &&
           VerifyOffset(verifier, VT_SRC) &&
           verifier.VerifyTable(src()) &&
           VerifyOffset(verifier, VT_DST) &&
           verifier.VerifyTable(dst()) &&
           VerifyField<uint8_t>(verifier, VT_COMPRESSION) &&
           VerifyField<uint8_t>(verifier, VT_PORT) &&
           VerifyField<uint8_t>(verifier, VT_SET_ORD) &&
           VerifyField<uint8_t>(verifier, VT_SET_CRIT) &&
           VerifyField<MVCNN::DMADescriptorReference>(verifier, VT_DESCRIPTOR) &&
           VerifyField<int32_t>(verifier, VT_DMA_HWP_ID) &&
           VerifyOffset(verifier, VT_ACT_COMPRESSION_SIZE_ENTRY) &&
           verifier.VerifyTable(act_compression_size_entry()) &&
           verifier.EndTable();
  }
};

struct NNDMATaskBuilder {
  typedef NNDMATask Table;
  flatbuffers::FlatBufferBuilder &fbb_;
  flatbuffers::uoffset_t start_;
  void add_src(flatbuffers::Offset<MVCNN::TensorReference> src) {
    fbb_.AddOffset(NNDMATask::VT_SRC, src);
  }
  void add_dst(flatbuffers::Offset<MVCNN::TensorReference> dst) {
    fbb_.AddOffset(NNDMATask::VT_DST, dst);
  }
  void add_compression(bool compression) {
    fbb_.AddElement<uint8_t>(NNDMATask::VT_COMPRESSION, static_cast<uint8_t>(compression), 0);
  }
  void add_port(uint8_t port) {
    fbb_.AddElement<uint8_t>(NNDMATask::VT_PORT, port, 0);
  }
  void add_set_ord(bool set_ord) {
    fbb_.AddElement<uint8_t>(NNDMATask::VT_SET_ORD, static_cast<uint8_t>(set_ord), 0);
  }
  void add_set_crit(bool set_crit) {
    fbb_.AddElement<uint8_t>(NNDMATask::VT_SET_CRIT, static_cast<uint8_t>(set_crit), 0);
  }
  void add_descriptor(const MVCNN::DMADescriptorReference *descriptor) {
    fbb_.AddStruct(NNDMATask::VT_DESCRIPTOR, descriptor);
  }
  void add_dma_hwp_id(int32_t dma_hwp_id) {
    fbb_.AddElement<int32_t>(NNDMATask::VT_DMA_HWP_ID, dma_hwp_id, 0);
  }
  void add_act_compression_size_entry(flatbuffers::Offset<MVCNN::TensorReference> act_compression_size_entry) {
    fbb_.AddOffset(NNDMATask::VT_ACT_COMPRESSION_SIZE_ENTRY, act_compression_size_entry);
  }
  explicit NNDMATaskBuilder(flatbuffers::FlatBufferBuilder &_fbb)
        : fbb_(_fbb) {
    start_ = fbb_.StartTable();
  }
  NNDMATaskBuilder &operator=(const NNDMATaskBuilder &);
  flatbuffers::Offset<NNDMATask> Finish() {
    const auto end = fbb_.EndTable(start_);
    auto o = flatbuffers::Offset<NNDMATask>(end);
    return o;
  }
};

inline flatbuffers::Offset<NNDMATask> CreateNNDMATask(
    flatbuffers::FlatBufferBuilder &_fbb,
    flatbuffers::Offset<MVCNN::TensorReference> src = 0,
    flatbuffers::Offset<MVCNN::TensorReference> dst = 0,
    bool compression = false,
    uint8_t port = 0,
    bool set_ord = false,
    bool set_crit = false,
    const MVCNN::DMADescriptorReference *descriptor = 0,
    int32_t dma_hwp_id = 0,
    flatbuffers::Offset<MVCNN::TensorReference> act_compression_size_entry = 0) {
  NNDMATaskBuilder builder_(_fbb);
  builder_.add_act_compression_size_entry(act_compression_size_entry);
  builder_.add_dma_hwp_id(dma_hwp_id);
  builder_.add_descriptor(descriptor);
  builder_.add_dst(dst);
  builder_.add_src(src);
  builder_.add_set_crit(set_crit);
  builder_.add_set_ord(set_ord);
  builder_.add_port(port);
  builder_.add_compression(compression);
  return builder_.Finish();
}

}  // namespace MVCNN

#endif  // FLATBUFFERS_GENERATED_DMA_MVCNN_H_
